# ExtendedTrait

import slogan, slogan.traits
import string, re

# Pseudo-trait used to configure the log line format dynamically, for the
# W3C extended logfile format. Like IgnoreTrait it has no data. Unlike
# IgnoreTrait it reads its input, looking for tokens that match other
# traits' 'extended' property, mapping unknown tokens to IgnoreTrait,
# and making a new entry in the list of logLine regexps to match the
# format specified.

class Trait(slogan.traits.Trait):
  identity= 'extended'
  size= []
  priority= -10

  def read(self, logpart):
    extendedTraits= []
    for extendedProperty in string.split(string.lower(logpart), ' '):
      thisTrait= slogan.traitObjects['ignore']
      for trait in slogan.traitObjects.values():
        if string.lower(trait.extended)==extendedProperty:
          thisTrait= trait
          break
      encoding= ''
      if '(' in extendedProperty:
        encoding= ['"', '+'][slogan.config['extendedMS']]
      extendedTraits.append('&'+encoding+thisTrait.identity+';')
    slogan.logLineFormats[slogan.logLineLength:]= [
      slogan.transformFormatString((string.join(extendedTraits, ' '), slogan.true))
    ]
    return []
